package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.webservice;


import cn.estsh.i3plus.ext.mes.apiservice.model.AssetInfo;
import cn.estsh.i3plus.ext.mes.apiservice.model.MeterInfo;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.busi.MaximoServiceImpl;
import cn.estsh.i3plus.ext.mes.pojo.model.MaximoParamModel;
import cn.estsh.impp.framework.boot.util.SpringContextsUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import java.util.Map;

@Component
@WebService(targetNamespace = "http://tempuri.org/")
public class WebServiceServer {
    public static final Logger LOGGER = LoggerFactory.getLogger(WebServiceServer.class);

    @WebMethod(action = "SyncMaximoEquip", operationName = "SyncMaximoEquip")
    public Map syncEquip(@WebParam(name = "assetInfo", targetNamespace = "http://schemas.datacontract.org/2004/07/WS.MAXIMO.DataInBound") AssetInfo assetInfo) {
        LOGGER.info("SyncMaximoEquip主数据:{}", assetInfo);
        MaximoParamModel maximoParamModel = new MaximoParamModel();
        maximoParamModel.setAssetNum(assetInfo.getASSETNUM());
        maximoParamModel.setStatus(assetInfo.getSTATUS());
        maximoParamModel.setSiteId(assetInfo.getSITEID());
        maximoParamModel.setFailureCode(assetInfo.getFAILURECODE());
        maximoParamModel.setDescription(assetInfo.getDESCRIPTION());
        MaximoServiceImpl bean = (MaximoServiceImpl)SpringContextsUtil.getBean("maximoServiceImpl");
        return bean.doAssetMainData(maximoParamModel);
    }

    @WebMethod(action = "SyncMaximoInstrument", operationName = "SyncMaximoInstrument")
    public Map syncInstrument(@WebParam(name = "meterInfo", targetNamespace = "http://schemas.datacontract.org/2004/07/WS.MAXIMO.DataInBound") MeterInfo meterInfo) {
        LOGGER.info("syncInstrument主数据:{}", meterInfo);
        MaximoParamModel maximoParamModel = new MaximoParamModel();
        maximoParamModel.setAssetNum(meterInfo.getASSETNUM());
        maximoParamModel.setBaseMeasureUnitId(meterInfo.getBASEMEASUREUNITID());
        maximoParamModel.setMeterName(meterInfo.getMETERNAME());
        MaximoServiceImpl bean = (MaximoServiceImpl)SpringContextsUtil.getBean("maximoServiceImpl");
        return bean.doAssetMainData(maximoParamModel);
    }

}